// Chat Utility for The Battle.net r0wbot by Deathr0w of f0rever.net
// pthreads support added June 2000

void chat(int sockfd, char *username)
{
  // starting ncurses init
  // +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ //
  // +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ //

  initscr();            // initialize the ncurses library
  start_color();	// initialize color ncurses functions
  keypad(stdscr, TRUE); // enable keyboard mapping
  nonl();               // tell curses not to do NL->CR/NL on output


  // Defining our color var's to 0 for now
  short cp_cyan = 0;
  short cp_yellow = 0;
  short cp_white = 0;
  short cp_red = 0;
  short cp_green = 0;
  short cp_blue = 0;
  short cp_bgblue = 0;

  int csupport = 0; // 0:FALSE 1:TRUE

  if(has_colors() == TRUE) {   // Does your terminal have color support?
    csupport = 1;

    // Color pairs: (cp for color pair)
    cp_cyan = 1;	// cyan on black
    cp_yellow = 2;	// yellow on black
    cp_white = 3;	// white on black
    cp_red = 4;		// red on black
    cp_green = 5;	// green on black
    cp_blue = 6;	// grey on black
    cp_bgblue = 7;	// white on blue

    // Initializing our color pairs (all are on a black background)
    init_pair(cp_cyan, COLOR_CYAN, COLOR_BLACK);
    init_pair(cp_yellow, COLOR_YELLOW, COLOR_BLACK);
    init_pair(cp_white, COLOR_WHITE, COLOR_BLACK);
    init_pair(cp_red, COLOR_RED, COLOR_BLACK);
    init_pair(cp_green, COLOR_GREEN, COLOR_BLACK);
    init_pair(cp_blue, COLOR_BLUE, COLOR_BLACK);
    init_pair(cp_bgblue, COLOR_WHITE, COLOR_BLUE);
  }
  else {   // no color support
    csupport = 0;
  }    

  WINDOW *win_recv;
  WINDOW *win_send;
  WINDOW *win_time;
  WINDOW *win_user;
  WINDOW *win_channel;
  WINDOW *win_version;
  WINDOW *win_r0wbot;

  // NEW and INDEPENDENT!
  win_recv = newwin((LINES-3), COLS, 0, 0);
  win_send = newwin(1, (COLS-10), (LINES-1), 10);
  win_r0wbot = newwin(1, 10, (LINES-1), 0);
  win_time = newwin(1, 10, (LINES-2), 0);
  win_user = newwin(1, 19, (LINES-2), 10);
  win_channel = newwin(1, 22, (LINES-2), 29);
  win_version = newwin(1, 16, (LINES-2), (COLS-17));


  wrefresh(win_recv);
  wrefresh(win_time);
  wrefresh(win_user);
  wrefresh(win_channel);
  wrefresh(win_version);
  wrefresh(win_r0wbot);
  wrefresh(win_send);	// calling refresh on this window last keeps the
                        // cursor blinking in the correct spot.

  // sets our window colors
  if(csupport == 1) {
    wattron(win_time, COLOR_PAIR(cp_bgblue));
    wattron(win_user, COLOR_PAIR(cp_bgblue));
    wattron(win_channel, COLOR_PAIR(cp_bgblue));
    wattron(win_version, COLOR_PAIR(cp_bgblue));
  }


  // Making sure all windows have the ability to scroll.
  // This makes updating their contents easier.
  idlok(win_recv, TRUE);
  scrollok(win_recv, TRUE);

  idlok(win_send, TRUE);
  scrollok(win_send, TRUE);

  idlok(win_time, TRUE);
  scrollok(win_time, TRUE);

  idlok(win_user, TRUE);
  scrollok(win_user, TRUE);

  idlok(win_channel, TRUE);
  scrollok(win_channel, TRUE);

  idlok(win_version, TRUE);
  scrollok(win_version, TRUE);

  idlok(win_r0wbot, TRUE);
  scrollok(win_r0wbot, TRUE);

  // +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ //
  // +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ //
  // end ncurses init

  pthread_t input_tid;
  pthread_t recv_tid;
  time_t mytime;
  int ilog = 0;   // 0 = off  and  1 = on
  // ofstream filewrite("r0wbot.log", ios::app);
  // filewrite.close();


  // updating current username (only needed once)
  // char user[256];
  // sprintf(user, "[%s]", username);
  waddch(win_user, '[');
  waddstr(win_user, username);
  waddch(win_user, ']');
  wrefresh(win_user);
  wrefresh(win_send);  // replace cursor

  // updating version (only needed once)
  waddstr(win_version, "[r0wbot v1.1.14]");
  wrefresh(win_version);
  wrefresh(win_send);  // replace cursor

  // updating r0wbot win_send header (only needed once)
  waddstr(win_r0wbot, "[r0wbot]: ");
  wrefresh(win_r0wbot);
  wrefresh(win_send);  // replace cursor



    threadpack InputPack;
      InputPack.SetUser(username);
      InputPack.p_sockfd = sockfd;
      InputPack.p_ilog = ilog;
      InputPack.p_csupport = csupport;
      InputPack.p_green = cp_green;
      InputPack.p_cyan = cp_cyan;
      InputPack.p_bgblue = cp_bgblue;
      InputPack.p_mytime = mytime;
      InputPack.p_winsend = win_send;
      InputPack.p_winrecv = win_recv;
      InputPack.p_winchannel = win_channel;

    threadpack RecvPack;
      RecvPack.p_wintime = win_time;
      RecvPack.p_winrecv = win_recv;
      RecvPack.p_winsend = win_send;
      RecvPack.p_sockfd = sockfd;
      RecvPack.p_csupport = csupport;
      RecvPack.p_green = cp_green;
      RecvPack.p_cyan = cp_cyan;
      RecvPack.p_red = cp_red;
      RecvPack.p_yellow = cp_yellow;
      RecvPack.p_white = cp_white;
      RecvPack.p_blue = cp_blue;

    pthread_create(&recv_tid, NULL, &getrecv, &RecvPack);
    pthread_create(&input_tid, NULL, &getinput, &InputPack);


  for( ; ; ) {
    // updating the time
    waddch(win_time, '\n');
    waddch(win_time, '[');
    waddstr(win_time, rclock());
    waddch(win_time, ']');
    wrefresh(win_time);
    wrefresh(win_send);

    // anti-idle function, handles everything locally
    if( anti_idle == 0) {
      idlebot(sockfd, win_recv);
      wrefresh(win_send);
    }
    sleep(5);
  }
}
