// Event Parse Utility - use in Conjunction with Event Handling Utility
// by Deathr0w of f0rever.net - 2000.April.1

class Event
{
  public:
    Event(char *);
    ~Event();

    void SetIDnum();
    const char* GetIDnum();

    void SetIDuser();
    const char* GetIDuser();

    void SetMessage();
    const char* GetMessage();


  private:
    int i;
    int j;
    int bufflen;

    char eBuffer[512]; // was 4096
    char eIDnum[5];
    char eIDuser[16];
    char eMessage[256]; // was 512
};



Event::Event(char *buffer)
{
  i = 0;
  j = 0;
  bufflen = 0;
  bufflen = strlen(buffer);

  memset(eBuffer, '\0', sizeof(eBuffer));
  memset(eIDnum, '\0', sizeof(eIDnum));
  memset(eIDuser, '\0', sizeof(eIDuser));
  memset(eMessage, '\0', sizeof(eMessage));

  strncpy(eBuffer, buffer, sizeof(eBuffer));
}

Event::~Event()
{;}



void Event::SetIDnum()
{
  i = 0;
  j = 0;

  while( eBuffer[i] != ' ') {
    eIDnum[j] = eBuffer[i];
    ++i;
    ++j;
  }

  // skipping over ID name, ID number is easier to use
  ++i;   // the first char in the Event Name field is array element 4
  while( eBuffer[i] != ' ') {
    ++i;
  }
}

const char* Event::GetIDnum()
{
  return eIDnum;
}



void Event::SetIDuser()
{
  i = 5;   // element 5 is the first character of the ID name
  j = 0;

  // takes i up to the space following the ID name
  while( eBuffer[i] != ' ') {
    ++i;
  }

  ++i;   // bumps i up to the first character of IDuser

  while( eBuffer[i] != ' ' && j < 15) {
    eIDuser[j] = eBuffer[i];
    ++i;
    ++j;
  }
}

const char* Event::GetIDuser()
{
  return eIDuser;
}



void Event::SetMessage()
{
  // New (independent) Message Capturing Function

  bufflen = strlen(eBuffer);
  i = 0;
  j = 0;

  // < 256 so i eBuffer is not pushed beyond the length of recvline[512]
  // this was the source of that segfault problem that was a major pain
  while(eBuffer[i] != '\"' && i < 256) {
    ++i;
  }

  ++i;

  // Original method:
  // while( (eBuffer[i] != '\"') && (eBuffer[(i+1)] != '\0') ) {
  //   eMessage[j] = eBuffer[i];
  //   ++i; ++j;
  // }

  // I have to run through eBuffer[] until I encounter a '\r'. (I think a
  // message sent from bnet always ends in "\r\n") If I do that as
  // follows, int i; should be the exact letter representing the closing
  // set of quotes. After that is determined, I should be able to simply
  // print eBuffer[] from the first quotes to the closing quotes, that
  // would in fact contain the message in it's entirity.
  // Note: this method works great, for now.

  // finding last quote:
  int k = 0;
  while(eBuffer[k] != '\r') {
    ++k;
  }

  j = 0;
  while( i < (k - 1)) {
    eMessage[j] = eBuffer[i];
    ++i; ++j;
  }

}

const char* Event::GetMessage()
{
  return eMessage;
  memset(eMessage, '\0', 512);
}
