// This class takes in a buffer and separates that buffer into individual
// lines. Each line is stored seperately in its own buffer(.cpp) object.
// Deathr0w 2000, May 10

class lineparse
{
  public:
    lineparse(char *);
    ~lineparse();

    void count();
    int GetCount();

    void split();

    const char * GetLine(int);

  private:
    uint i;
    uint j;
    uint linecount;	// # of lines in the buffer
    uint cline;		// # of the current line

    char recvbuffer[4096];
    char linebuffer[512];

    buffer line[64];	// 64 lines shouldn't gather up... i don't think
};


lineparse::lineparse(char *recvbuff)
{
  strncpy(recvbuffer, recvbuff, 4096);

  i = 0;
  j = 0;
  linecount = 0;
  cline = 0;
}


lineparse::~lineparse()
{ ; }


void lineparse::count()
{
  i = 0;
  linecount = 0;

  while(i != strlen(recvbuffer)) {
    if(recvbuffer[i] == '\n') {
      ++linecount;
    }

    ++i;
  }
}


int lineparse::GetCount()
{
  return linecount;
}


void lineparse::split()
{
  i = 0;
  j = 0;
  cline = 0;

  while(cline != linecount) {
    while(recvbuffer[i] != '\n') {
      linebuffer[j] = recvbuffer[i];
      ++i; ++j;
    }

    ++i;
    j = 0;

    line[cline].SetLine(linebuffer);
    ++cline;
  }
}


const char * lineparse::GetLine(int linenum)
{
  strncpy(linebuffer, (line[linenum].GetLine()), 512);
  return linebuffer;
}
