// This file contains all the include's and define's for The Battle.net r0wbot

#include        <sys/types.h>   // basic system data types
#include        <sys/socket.h>  // basic socket definitions
#include        <sys/time.h>    // timeval{} for select()
#include        <time.h>        // timespec{} for pselect()
#include        <netinet/in.h>  // sockaddr_in{} and other Internet defns
#include        <arpa/inet.h>   // inet(3) functions
#include        <errno.h>
#include        <netdb.h>
#include        <signal.h>
#include        <stdio.h>
#include        <stdlib.h>
#include        <string.h>
#include        <unistd.h>
#include        <sys/wait.h>
#include        <fstream.h>	// C++ only
#include	<ncurses.h>	// window layout
#include	<pthread.h>	// posix threads

#define max(a,b)        ((a) > (b) ? (a) : (b))
#define SHUT_RD         0
#define SHUT_WR         1
#define SHUT_RDWR       2

typedef unsigned short int ushort;
typedef unsigned int uint;


// For all of my True/False variables, 0=True  1=False

uint ilog = 1;		// Are we logging incoming data?
uint firstlog = 1;	// Is this the first log entry?
uint lastlog = 1;	// Is this the last log entry?
uint notify = 0;	// Display enter/leave notifications?
uint rfilter = 1;	// Enjoy freedom of speech? filter = 1 if you do

uint anti_idle = 1;	// To idle or not to idle, that is the question.
uint idlesent3 = 1;	// Have you already sent the anti-idle?
uint idlesent6 = 1;
uint idlesent9 = 1;


#include "buffer.cpp"			// stores char arrays for lineparse
#include "lineparse.cpp"		// separates a multiline buffer
#include "clock.cpp"			// gets the time and formats it
#include "connector.cpp"		// connection process
#include "login.cpp"			// login process
#include "eparse.cpp"			// event parsing (class definitions)
#include "convert.cpp"			// int for ehandler switch
#include "ehandler.cpp"			// event handling
#include "readline.cpp"			// reads a string, line by line
#include "channel.cpp"			// stores channel name
#include "ccatch.cpp"			// command catching
#include "idle.cpp"			// handles anti-idle operations
#include "strfilter.cpp"		// disables/enables censorship
#include "threadpack.cpp"		// holds all of getinput()'s args
#include "getinput.cpp"			// gets user input (threaded)
#include "getrecv.cpp"			// gets received info (threaded)
#include "chat-pthreads.cpp"		// chatting function (threaded)
